/* Print out the averages and autocorrelations */

#include "comext.h"
#include <math.h>
#include <string.h>
#include <stdio.h>

extern float dilution, actual_dilution;

void printdata(outname)
char outname[128];
{
char fileerror[128],filename[128];
char dataname[128],cdistname[128];
FILE *fopen(), *fpax, *fpns;
FILE *fpe, *fpe2, *fpm, *fpm2;
int i,j,m,n,t;
float spec_heat,suscept;
double tmp;

    /* Open output file */
    sprintf(dataname, "BFC.%s", outname); fpax = fopen(dataname,"w");

  if (cntenergy) {
     
     numbins = cntenergy/binsz;
     for (m=0;m<M;m++) {
        avenergy[m] /= cntenergy;
        avenersq[m] /= cntenergy;
        avbinenersq[m] /= numbins;
        spheat[m] = avbinenersq[m] - avenergy[m]*avenergy[m];
        errener[m] = sqrt( spheat[m] / numbins );
        avspheat[m] /= numbins;
        avspheatsq[m] /= numbins;
        spheat[m] = avspheatsq[m] - avspheat[m]*avspheat[m];
        errspheat[m] = sqrt( spheat[m] / numbins );
        spheat[m] = avenersq[m] - avenergy[m]*avenergy[m];

        if (cntenergy >= NA)  	 /* finish energy autocorr */
           finish_autocorr(lastNEA,EA,avenergy,cntenergy,m);
     }

  }

  if (cntspin) {

     numbins = cntspin/binsz;
     for (m=0;m<M;m++) {
        avspin[m] /= cntspin;
        avspinsq[m] /= cntspin;
        avbinspinsq[m] /= numbins;
        suss[m] = avbinspinsq[m] - avspin[m]*avspin[m];
        errspin[m] = sqrt( suss[m] / numbins );
        avsuss[m] /= numbins;
        avsusssq[m] /= numbins;
        suss[m] = avsusssq[m] - avsuss[m]*avsuss[m];
        errsuss[m] = sqrt( suss[m] / numbins );
        suss[m] = avspinsq[m] - avspin[m]*avspin[m];

        if (cntspin >= NA)    /* finish spin autocorr */
          finish_autocorr(lastNMA,MA,avspin,cntspin,m);
     }

     n = 0;
     avmagsq[n] /= cntspin;
     avbinmagsqsq[n] /= numbins;
     errmagsq[n] = sqrt( (avbinmagsqsq[n] - avmagsq[n]*avmagsq[n]) / numbins);
     for (m=0;m<M;m++) {
        avimsuss[m] /= numbins;
        avimsusssq[m] /= numbins;
        imsuss[m] = avimsusssq[m] - avimsuss[m]*avimsuss[m];
        errimsuss[m] = sqrt( imsuss[m] / numbins );
        imsuss[m] = avmagsq[n] - avspin[m]*avspin[m];
     }

     if (cntspin >= NA)    
        finish_autocorr(lastNM2A,M2A,avmagsq,cntspin,n);
  }


/* Print out results */

fprintf(fpax,"Beta = %f  totswps = %d\n",beta,totswps);
if (glass) {
   fprintf(fpax,"dilution = %f  %f\n", dilution, actual_dilution);
}
fprintf(fpax,"Sites = %d x %d = %d\n", isiz,jsiz,sites);
fprintf(fpax,"Sweeps per measurement = %d\n", sweeps);
fprintf(fpax,"\n");

/* Energy and specific heat */
for (m=0;m<M;m++)
fprintf(fpax,"E (%d) = %f +/- %f\n", cntenergy,avenergy[m],errener[m]);
for (m=0;m<M;m++)
fprintf(fpax,"Sp heat (%d) = %f  :  %f +/- %f\n", 
	cntenergy/binsz,sites*spheat[m],sites*avspheat[m],sites*errspheat[m]);
fprintf(fpax,"\n");

/* Magnetization and susceptibility */
for (m=0;m<M;m++)
fprintf(fpax,"Mag (%d) = %f +/- %f\n", cntspin,avspin[m],errspin[m]);
for (m=0;m<M;m++)
fprintf(fpax,"Susp (%d) = %f  :  %f +/- %f\n", 
	cntspin/binsz,sites*suss[m],sites*avsuss[m],sites*errsuss[m]);
fprintf(fpax,"\n");

/* Magnetization and susceptibility from Magsq*/
n = 0;
#ifdef SW
fprintf(fpax,"Magsq (%d) = %f +/- %f\n", cntspin,avmagsq[n],errmagsq[n]);
#endif
#ifdef WOLFF
fprintf(fpax,"Magsq (%d) = %f +/- %f\n", cntspin,avmagsq[n],errmagsq[n]);
#endif
#ifdef METROPOLIS
fprintf(fpax,"Acceptance (%d) = %f +/- %f\n", cntspin,avmagsq[n],errmagsq[n]);
#endif
fprintf(fpax,"\n");

/* Maxima and minima of energies and spins */
for (m=0;m<M;m++) {
fprintf(fpax,"Emin =%10.6f   Emax =%10.6f\n", minenergy[m],maxenergy[m]);
fprintf(fpax,"Mmin =%10.6f   Mmax =%10.6f\n", minspin[m],maxspin[m]);
}
fprintf(fpax,"\n");

/* Autocorrelations in the energy and magnetization */
if (cntenergy >= NA) {
  fprintf(fpax,"Auto correlations\n");
  fprintf(fpax,"\n");
/*
  fprintf(fpax,"        Energy                  Magnetization\n");
  fprintf(fpax,"\n");
  for (i=0;i<NA;i++)
     fprintf(fpax,"%3d  %10.6f +/- %f  %10.6f +/- %f\n", 
	     i, EA[i]/EA[0], errEA[i]/EA[0], MA[i]/MA[0], errMA[i]/MA[0]);
  fprintf(fpax,"\n");
*/
  fprintf(fpax,"       Energy                  Magnetization\n");
  fprintf(fpax,"\n");
  for (i=0;i<NA;i++) {
     fprintf(fpax,"%3d  ", i); 
     for (m=0;m<M;m++)
        fprintf(fpax,"%10.6f  ", EA[m][i]/EA[m][0]);
     for (m=0;m<M;m++)
        fprintf(fpax,"%10.6f  ", MA[m][i]/MA[m][0]);
     fprintf(fpax,"\n");
  }
  fprintf(fpax,"\n");

/* Autocorrelation length for the energy and magnetization */
  fprintf(fpax,"Auto correlation length\n");
  fprintf(fpax,"\n");
  for (i=1;i<NA;i++) {
     fprintf(fpax,"%3d  ", i);
     for (m=0;m<M;m++) {
        mass = EA[m][i-1]/EA[m][i];
        if (mass > 0) mass = 1./log(mass);
        else          mass = 0.;
        fprintf(fpax,"%10.6f  ", mass);
     }
     for (m=0;m<M;m++) {
        mass = MA[m][i-1]/MA[m][i];
        if (mass > 0) mass = 1./log(mass);
        else          mass = 0.;
        fprintf(fpax,"%10.6f  ", mass);
     }
     fprintf(fpax,"\n");
  }
}

/* Autocorrelations in the magnetization squared */
if (cntspin >= NA) {
  fprintf(fpax,"\n");
  fprintf(fpax,"Auto correlations\n");
  fprintf(fpax,"\n");
  fprintf(fpax,"       Magsq\n");
  fprintf(fpax,"\n");
  for (i=0;i<NA;i++) {
     fprintf(fpax,"%3d  ", i);
     n = 1;
     for (m=0;m<n;m++)
        fprintf(fpax,"%10.6f  ", M2A[m][i]/M2A[m][0]);
     fprintf(fpax,"\n");
  }
  fprintf(fpax,"\n");

  fprintf(fpax,"Auto correlation length\n");
  fprintf(fpax,"\n");
  for (i=1;i<NA;i++) {
     fprintf(fpax,"%3d  ", i);
     for (m=0;m<n;m++) {
        mass = M2A[m][i-1]/M2A[m][i];
        if (mass > 0) mass = 1./log(mass);
        else          mass = 0.;
        fprintf(fpax,"%10.6f  ", mass);
     }
     fprintf(fpax,"\n");
  }
}
  
  fclose(fpax);

}



/* FUNCTIONS */

finish_autocorr(lastNA,A,average,count,m)
double lastNA[M][MAXNA], A[M][MAXNA];
double average[M];
int count, m;
{
   int i,j;

   /* Finish off the last bits which haven't been done yet */
   for (j=0;j<NA;j++) {
      for (i=1;i<NA;i++)
	 lastNA[m][i-1] = lastNA[m][i];
      lastNA[m][NA-1] = 0;
      for (i=0;i<NA;i++)
	 A[m][i] += lastNA[m][0] * lastNA[m][i];
   }
   /* Scale the autocorrs */
   /* Miss out NA-1 values at the start, and get an extra NA-(i+1)
      at the end, so need to subtract i from count to scale them */
   for (i=0;i<NA;i++) {
      A[m][i] /= (count-i);
      A[m][i] -= (average[m] * average[m]);
   }
}

